<template>
  <div
    :id="id"
    :class="['mt1 pt1 pl1 pr1 border-radius-m bg-gray-5 accordion__block', {'accordion__block--active': isActive}]"
  >
    <div
      class="p3 pb1 black-1 bg-gray-4 accordion__label"
      @click="maybeActivate()"
    >
      <div class="accordion__icon">
        <IconAngleDown/>
      </div>
      <slot name="header" />
    </div>
    <div
      :is="component"
      mode="expand"
    >
      <div
        v-show="isActive"
        class="pt1 mb1 bg-gray-5 accordion__content"
      >
        <div class="p4 black-1 accordion__content-inner">
          <slot name="content" />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import TransitionMenuSubExpand from './../transition-menu-sub-expand/transition-menu-sub-expand'

let uuid = 0

export default {
  inject: ['registerBlock', 'accordion'],
  components: { TransitionMenuSubExpand },
  props: {
    id: {
      type: String,
      default: ''
    },
    className: {
      type: String,
      default: ''
    },
    duration: {
      type: Number,
      default: 400
    },
    active: Boolean
  },
  data () {
    return {
      isActive: this.active,
      uuid
    }
  },
  computed: {
    component () {
      if (this.accordion.isInit) {
        return TransitionMenuSubExpand
      }
      return 'div'
    }
  },
  created () {
    uuid++
  },
  mounted () {
    this.registerBlock(this)
  },
  methods: {
    maybeActivate () {
      this.isActive = !this.isActive
      if (this.isActive) {
        this.$emit('activate-block', this.uuid)
        this.$nextTick(() => {
          this.$el
        })
      }
    },
    activate () {
      this.isActive = true
    },
    deactivate () {
      this.isActive = false
    }
  }
}
</script>
<style lang="scss" scoped>
@import "@/assets/base/variables";

.accordion__block {
  position: relative;
  max-width: 872px;
}

.accordion__label {
  cursor: pointer;
}

.accordion__icon {
  position: absolute;
  top: 26px;
  right: 16px;
  transform: translateY(-50%);

  .accordion__block--active & {
    svg {
      transform: rotate(180deg);
    }
  }
}
.accordion__content {
  border-top: 1px solid $c-gray-2;
}
</style>
